package com.trafficparrot.examples.hello.http;

import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

public class HelloWorldHttpIntegrationTest {
    private static final String HTTP_VS = "http://localhost:18081";

    @Test(timeout = 30_000)
    public void helloHttpWorld() throws IOException {
        try (CloseableHttpClient httpclient = HttpClients.createDefault()) {
            HttpPost request = new HttpPost(HTTP_VS + "/path");
            request.setEntity(new StringEntity("hello"));
            try (CloseableHttpResponse response = httpclient.execute(request)) {
                int statusCode = response.getStatusLine().getStatusCode();
                String responseBody = EntityUtils.toString(response.getEntity());

                assertThat(statusCode, is(200));
                assertThat(responseBody, is("world"));
            }
        }
    }

    @Before
    public void setUp() throws Exception {
        displayAllMappings();
    }

    private void displayAllMappings() throws IOException {
        try (CloseableHttpClient httpclient = HttpClients.createDefault()) {
            HttpGet request = new HttpGet(HTTP_VS + "/__admin");
            try (CloseableHttpResponse response = httpclient.execute(request)) {
                String allMappings = EntityUtils.toString(response.getEntity());
                System.out.println("All mappings: " + allMappings);
            }
        }
    }
}
