package com.trafficparrot.examples.hello.jms;

import com.trafficparrot.examples.tools.jms.JmsClient;
import com.trafficparrot.examples.tools.jms.WaitForOneJmsMessage;
import org.junit.Test;

import javax.jms.JMSException;
import java.io.IOException;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

public class HelloWorldJmsTopicIntegrationTest {
    private final JmsClient jmsClient = new JmsClient();

    @Test(timeout = 30_000)
    public void helloWorldJmsTopic() throws IOException, JMSException, InterruptedException {
        WaitForOneJmsMessage waitForOneJmsMessage = jmsClient.listenOnTopic("response.topic");
        jmsClient.sendTextMessageToTopic("request.topic", "hello");

        String response = waitForOneJmsMessage.awaitMessage();

        assertThat(response, is("world"));
    }
}
